searchNodes=[{"doc":"Floki is a simple HTML parser that enables search for nodes using CSS selectors. Example Assuming that you have the following HTML: &lt;!doctype html&gt; &lt;html&gt; &lt;body&gt; &lt;section id=&quot;content&quot;&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; &lt;a href=&quot;http://github.com/philss/floki&quot;&gt;Github page&lt;/a&gt; &lt;span data-model=&quot;user&quot;&gt;philss&lt;/span&gt; &lt;/section&gt; &lt;/body&gt; &lt;/html&gt; To parse this, you can use the function Floki.parse_document/1 : { :ok , html } = Floki . parse_document ( doc ) # =&gt; # [{&quot;html&quot;, [], # [ # {&quot;body&quot;, [], # [ # {&quot;section&quot;, [{&quot;id&quot;, &quot;content&quot;}], # [ # {&quot;p&quot;, [{&quot;class&quot;, &quot;headline&quot;}], [&quot;Floki&quot;]}, # {&quot;a&quot;, [{&quot;href&quot;, &quot;http://github.com/philss/floki&quot;}], [&quot;Github page&quot;]}, # {&quot;span&quot;, [{&quot;data-model&quot;, &quot;user&quot;}], [&quot;philss&quot;]} # ]} # ]} # ]}] With this document you can perform queries such as: Floki.find(html, &quot;#content&quot;) Floki.find(html, &quot;.headline&quot;) Floki.find(html, &quot;a&quot;) Floki.find(html, &quot;[data-model=user]&quot;) Floki.find(html, &quot;#content a&quot;) Floki.find(html, &quot;.headline, a&quot;) Each HTML node is represented by a tuple like: { tag_name , attributes , children_nodes } Example of node: { &quot;p&quot; , [ { &quot;class&quot; , &quot;headline&quot; } ] , [ &quot;Floki&quot; ] } So even if the only child node is the element text, it is represented inside a list.","ref":"Floki.html","title":"Floki","type":"module"},{"doc":"Changes the attribute values of the elements matched by selector with the function mutation and returns the whole element tree. Examples iex&gt; Floki . attr ( [ { &quot;div&quot; , [ { &quot;id&quot; , &quot;a&quot; } ] , [ ] } ] , &quot;#a&quot; , &quot;id&quot; , fn ( id ) -&gt; String . replace ( id , &quot;a&quot; , &quot;b&quot; ) end ) [ { &quot;div&quot; , [ { &quot;id&quot; , &quot;b&quot; } ] , [ ] } ] iex&gt; Floki . attr ( [ { &quot;div&quot; , [ { &quot;class&quot; , &quot;name&quot; } ] , [ ] } ] , &quot;div&quot; , &quot;id&quot; , fn _ -&gt; &quot;b&quot; end ) [ { &quot;div&quot; , [ { &quot;id&quot; , &quot;b&quot; } , { &quot;class&quot; , &quot;name&quot; } ] , [ ] } ]","ref":"Floki.html#attr/4","title":"Floki.attr/4","type":"function"},{"doc":"Returns a list with attribute values from elements. Examples iex&gt; Floki . attribute ( [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ] , &quot;href&quot; ) [ &quot;https://google.com&quot; ] iex&gt; Floki . attribute ( [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } , { &quot;data-name&quot; , &quot;google&quot; } ] , [ &quot;Google&quot; ] } ] , &quot;data-name&quot; ) [ &quot;google&quot; ]","ref":"Floki.html#attribute/2","title":"Floki.attribute/2","type":"function"},{"doc":"Returns a list with attribute values for a given selector. Examples iex&gt; Floki . attribute ( [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ] , &quot;a&quot; , &quot;href&quot; ) [ &quot;https://google.com&quot; ] iex&gt; Floki . attribute ( [ { &quot;a&quot; , [ { &quot;class&quot; , &quot;foo&quot; } , { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ] , &quot;a&quot; , &quot;class&quot; ) [ &quot;foo&quot; ] iex&gt; Floki . attribute ( [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } , { &quot;data-name&quot; , &quot;google&quot; } ] , [ &quot;Google&quot; ] } ] , &quot;a[data-name]&quot; , &quot;data-name&quot; ) [ &quot;google&quot; ]","ref":"Floki.html#attribute/3","title":"Floki.attribute/3","type":"function"},{"doc":"Returns the direct child nodes of a HTML node. By default, it will also include all texts. You can disable this behaviour by using the option include_text to false . If the given node is not an HTML tag, then it returns nil. Examples iex&gt; Floki . children ( { &quot;div&quot; , [ ] , [ &quot;text&quot; , { &quot;span&quot; , [ ] , [ ] } ] } ) [ &quot;text&quot; , { &quot;span&quot; , [ ] , [ ] } ] iex&gt; Floki . children ( { &quot;div&quot; , [ ] , [ &quot;text&quot; , { &quot;span&quot; , [ ] , [ ] } ] } , include_text : false ) [ { &quot;span&quot; , [ ] , [ ] } ] iex&gt; Floki . children ( { :comment , &quot;comment&quot; } ) nil","ref":"Floki.html#children/2","title":"Floki.children/2","type":"function"},{"doc":"Returns the nodes from a HTML tree that don't match the filter selector. Examples iex&gt; Floki . filter_out ( { &quot;div&quot; , [ ] , [ { &quot;script&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } , &quot;script&quot; ) { &quot;div&quot; , [ ] , [ &quot; world&quot; ] } iex&gt; Floki . filter_out ( [ { &quot;body&quot; , [ ] , [ { &quot;script&quot; , [ ] , [ ] } , { &quot;div&quot; , [ ] , [ ] } ] } ] , &quot;script&quot; ) [ { &quot;body&quot; , [ ] , [ { &quot;div&quot; , [ ] , [ ] } ] } ] iex&gt; Floki . filter_out ( { &quot;div&quot; , [ ] , [ { :comment , &quot;comment&quot; } , &quot; text&quot; ] } , :comment ) { &quot;div&quot; , [ ] , [ &quot; text&quot; ] } iex&gt; Floki . filter_out ( { &quot;div&quot; , [ ] , [ &quot;text&quot; ] } , :text ) { &quot;div&quot; , [ ] , [ ] }","ref":"Floki.html#filter_out/2","title":"Floki.filter_out/2","type":"function"},{"doc":"Find elements inside a HTML tree or string. Examples iex&gt; { :ok , html } = Floki . parse_fragment ( &quot;&lt;p&gt;&lt;span class=hint&gt;hello&lt;/span&gt;&lt;/p&gt;&quot; ) iex&gt; Floki . find ( html , &quot;.hint&quot; ) [ { &quot;span&quot; , [ { &quot;class&quot; , &quot;hint&quot; } ] , [ &quot;hello&quot; ] } ] iex&gt; { :ok , html } = Floki . parse_fragment ( &quot;&lt;div id=important&gt;&lt;div&gt;Content&lt;/div&gt;&lt;/div&gt;&quot; ) iex&gt; Floki . find ( html , &quot;#important&quot; ) [ { &quot;div&quot; , [ { &quot;id&quot; , &quot;important&quot; } ] , [ { &quot;div&quot; , [ ] , [ &quot;Content&quot; ] } ] } ] iex&gt; { :ok , html } = Floki . parse_fragment ( &quot;&lt;p&gt;&lt;a href=&#39;https://google.com&#39;&gt;Google&lt;/a&gt;&lt;/p&gt;&quot; ) iex&gt; Floki . find ( html , &quot;a&quot; ) [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ] iex&gt; Floki . find ( [ { &quot;div&quot; , [ ] , [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ] } ] , &quot;div a&quot; ) [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://google.com&quot; } ] , [ &quot;Google&quot; ] } ]","ref":"Floki.html#find/2","title":"Floki.find/2","type":"function"},{"doc":"Searches for elements inside the HTML tree and update those that matches the selector. It will return the updated HTML tree. This function works in a way similar to traverse_and_update , but instead of updating the children nodes, it will only updates the tag and attributes of the matching nodes. If fun returns :delete , the HTML node will be removed from the tree. Examples iex&gt; Floki . find_and_update ( [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;http://elixir-lang.com&quot; } ] , [ &quot;Elixir&quot; ] } ] , &quot;a&quot; , fn iex&gt; { &quot;a&quot; , [ { &quot;href&quot; , href } ] } -&gt; iex&gt; { &quot;a&quot; , [ { &quot;href&quot; , String . replace ( href , &quot;http://&quot; , &quot;https://&quot; ) } ] } iex&gt; other -&gt; iex&gt; other iex&gt; end ) [ { &quot;a&quot; , [ { &quot;href&quot; , &quot;https://elixir-lang.com&quot; } ] , [ &quot;Elixir&quot; ] } ]","ref":"Floki.html#find_and_update/3","title":"Floki.find_and_update/3","type":"function"},{"doc":"","ref":"Floki.html#map/2","title":"Floki.map/2","type":"function"},{"doc":"Parses a HTML Document from a String. The expect string is a valid HTML, but the parser will try to parse even with errors.","ref":"Floki.html#parse/1","title":"Floki.parse/1","type":"function"},{"doc":"Parses a HTML Document from a string. It will use the available parser from application env or the one from the :html_parser option. Check https://github.com/philss/floki#alternative-html-parsers for more details. Examples iex&gt; Floki . parse_document ( &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;hello&lt;/body&gt;&lt;/html&gt;&quot; ) { :ok , [ { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ &quot;hello&quot; ] } ] } ] } iex&gt; Floki . parse_document ( &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;hello&lt;/body&gt;&lt;/html&gt;&quot; , html_parser : Floki.HTMLParser.Mochiweb ) { :ok , [ { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ &quot;hello&quot; ] } ] } ] }","ref":"Floki.html#parse_document/2","title":"Floki.parse_document/2","type":"function"},{"doc":"Parses a HTML Document from a string. Similar to Floki.parse_document/1 , but raises Floki.ParseError if there was an error parsing the document. Example iex&gt; Floki . parse_document! ( &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;hello&lt;/body&gt;&lt;/html&gt;&quot; ) [ { &quot;html&quot; , [ ] , [ { &quot;head&quot; , [ ] , [ ] } , { &quot;body&quot; , [ ] , [ &quot;hello&quot; ] } ] } ]","ref":"Floki.html#parse_document!/2","title":"Floki.parse_document!/2","type":"function"},{"doc":"Parses a HTML fragment from a string. It will use the available parser from application env or the one from the :html_parser option. Check https://github.com/philss/floki#alternative-html-parsers for more details.","ref":"Floki.html#parse_fragment/2","title":"Floki.parse_fragment/2","type":"function"},{"doc":"Parses a HTML fragment from a string. Similar to Floki.parse_fragment/1 , but raises Floki.ParseError if there was an error parsing the fragment.","ref":"Floki.html#parse_fragment!/2","title":"Floki.parse_fragment!/2","type":"function"},{"doc":"Converts HTML tree to raw HTML. Note that the resultant HTML may be different from the original one. Spaces after tags and doctypes are ignored. Options :encode : accepts true or false . Will encode html special characters to html entities. You can also control the encoding behaviour at the application level via config :floki, :encode_raw_html, true | false :pretty : accepts true or false . Will format the output, ignoring breaklines and spaces from the input and putting new ones in order to pretty format the html. Examples iex&gt; Floki . raw_html ( { &quot;div&quot; , [ { &quot;class&quot; , &quot;wrapper&quot; } ] , [ &quot;my content&quot; ] } ) ~s(&lt;div class=&quot;wrapper&quot;&gt;my content&lt;/div&gt;) iex&gt; Floki . raw_html ( { &quot;div&quot; , [ { &quot;class&quot; , &quot;wrapper&quot; } ] , [ &quot;10 &gt; 5&quot; ] } , encode : true ) ~s(&lt;div class=&quot;wrapper&quot;&gt;10 &amp;gt; 5&lt;/div&gt;) iex&gt; Floki . raw_html ( { &quot;div&quot; , [ { &quot;class&quot; , &quot;wrapper&quot; } ] , [ &quot;10 &gt; 5&quot; ] } , encode : false ) ~s(&lt;div class=&quot;wrapper&quot;&gt;10 &gt; 5&lt;/div&gt;) iex&gt; Floki . raw_html ( { &quot;div&quot; , [ ] , [ &quot; \\n &quot; , { &quot;span&quot; , [ ] , &quot;Fully indented&quot; } , &quot; \\n &quot; ] } , pretty : true ) &quot;&quot;&quot; &lt;div&gt; &lt;span&gt; Fully indented &lt;/span&gt; &lt;/div&gt; &quot;&quot;&quot;","ref":"Floki.html#raw_html/2","title":"Floki.raw_html/2","type":"function"},{"doc":"Returns the text nodes from a HTML tree. By default, it will perform a deep search through the HTML tree. You can disable deep search with the option deep assigned to false. You can include content of script tags with the option js assigned to true. You can specify a separator between nodes content. Examples iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;span&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } ) &quot;hello world&quot; iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;span&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } , deep : false ) &quot; world&quot; iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;script&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } ) &quot; world&quot; iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;script&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } , js : true ) &quot;hello world&quot; iex&gt; Floki . text ( { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] } , { &quot;li&quot; , [ ] , [ &quot;world&quot; ] } ] } , sep : &quot;-&quot; ) &quot;hello-world&quot; iex&gt; Floki . text ( [ { &quot;div&quot; , [ ] , [ &quot;hello world&quot; ] } ] ) &quot;hello world&quot; iex&gt; Floki . text ( [ { &quot;p&quot; , [ ] , [ &quot;1&quot; ] } , { &quot;p&quot; , [ ] , [ &quot;2&quot; ] } ] ) &quot;12&quot; iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;style&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } , style : false ) &quot; world&quot; iex&gt; Floki . text ( { &quot;div&quot; , [ ] , [ { &quot;style&quot; , [ ] , [ &quot;hello&quot; ] } , &quot; world&quot; ] } , style : true ) &quot;hello world&quot;","ref":"Floki.html#text/2","title":"Floki.text/2","type":"function"},{"doc":"Traverses and updates a HTML tree structure. This function returns a new tree structure that is the result of applying the given fun on all nodes except text nodes. The tree is traversed in a post-walk fashion, where the children are traversed before the parent. When the function fun encounters HTML tag, it receives a tuple with {name, attributes, children} , and should either return a similar tuple, a list of tuples to split current node or nil to delete it. The function fun can also encounter HTML doctype, comment or declaration and will receive, and should return, different tuple for these types. See the documentation for html_comment/0 , html_doctype/0 and html_declaration/0 for details. Note : this won't update text nodes, but you can transform them when working with children nodes. Examples iex&gt; html = [ { &quot;div&quot; , [ ] , [ &quot;hello&quot; ] } ] iex&gt; Floki . traverse_and_update ( html , fn ...&gt; { &quot;div&quot; , attrs , children } -&gt; { &quot;p&quot; , attrs , children } ...&gt; other -&gt; other ...&gt; end ) [ { &quot;p&quot; , [ ] , [ &quot;hello&quot; ] } ] iex&gt; html = [ { &quot;div&quot; , [ ] , [ { :comment , &quot;I am comment&quot; } , { &quot;span&quot; , [ ] , [ &quot;hello&quot; ] } ] } ] iex&gt; Floki . traverse_and_update ( html , fn ...&gt; { &quot;span&quot; , _attrs , _children } -&gt; nil ...&gt; { :comment , text } -&gt; { &quot;span&quot; , [ ] , text } ...&gt; other -&gt; other ...&gt; end ) [ { &quot;div&quot; , [ ] , [ { &quot;span&quot; , [ ] , &quot;I am comment&quot; } ] } ]","ref":"Floki.html#traverse_and_update/2","title":"Floki.traverse_and_update/2","type":"function"},{"doc":"Traverses and updates a HTML tree structure with an accumulator. This function returns a new tree structure and the final value of accumulator which are the result of applying the given fun on all nodes except text nodes. The tree is traversed in a post-walk fashion, where the children are traversed before the parent. When the function fun encounters HTML tag, it receives a tuple with {name, attributes, children} and an accumulator. It and should return a 2-tuple like {new_node, new_acc} , where new_node is either a similar tuple or nil to delete the current node, and new_acc is an updated value for the accumulator. The function fun can also encounter HTML doctype, comment or declaration and will receive, and should return, different tuple for these types. See the documentation for html_comment/0 , html_doctype/0 and html_declaration/0 for details. Note : this won't update text nodes, but you can transform them when working with children nodes. Examples iex&gt; html = [ { &quot;div&quot; , [ ] , [ { :comment , &quot;I am a comment&quot; } , &quot;hello&quot; ] } , { &quot;div&quot; , [ ] , [ &quot;world&quot; ] } ] iex&gt; Floki . traverse_and_update ( html , 0 , fn ...&gt; { &quot;div&quot; , attrs , children } , acc -&gt; ...&gt; { { &quot;p&quot; , [ { &quot;data-count&quot; , to_string ( acc ) } | attrs ] , children } , acc + 1 } ...&gt; other , acc -&gt; { other , acc } ...&gt; end ) { [ { &quot;p&quot; , [ { &quot;data-count&quot; , &quot;0&quot; } ] , [ { :comment , &quot;I am a comment&quot; } , &quot;hello&quot; ] } , { &quot;p&quot; , [ { &quot;data-count&quot; , &quot;1&quot; } ] , [ &quot;world&quot; ] } ] , 2 } iex&gt; html = { &quot;div&quot; , [ ] , [ { &quot;span&quot; , [ ] , [ &quot;hello&quot; ] } ] } iex&gt; Floki . traverse_and_update ( html , [ deleted : 0 ] , fn ...&gt; { &quot;span&quot; , _attrs , _children } , acc -&gt; ...&gt; { nil , Keyword . put ( acc , :deleted , acc [ :deleted ] + 1 ) } ...&gt; tag , acc -&gt; ...&gt; { tag , acc } ...&gt; end ) { { &quot;div&quot; , [ ] , [ ] } , [ deleted : 1 ] }","ref":"Floki.html#traverse_and_update/3","title":"Floki.traverse_and_update/3","type":"function"},{"doc":"","ref":"Floki.html#t:css_selector/0","title":"Floki.css_selector/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_attribute/0","title":"Floki.html_attribute/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_comment/0","title":"Floki.html_comment/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_declaration/0","title":"Floki.html_declaration/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_doctype/0","title":"Floki.html_doctype/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_node/0","title":"Floki.html_node/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_tag/0","title":"Floki.html_tag/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_text/0","title":"Floki.html_text/0","type":"type"},{"doc":"","ref":"Floki.html#t:html_tree/0","title":"Floki.html_tree/0","type":"type"},{"doc":"A entry point to dynamic dispatch functions to the configured HTML parser. The configuration can be done with the :html_parser option when calling the functions, or for the :floki application: Floki . parse_document ( document , html_parser : Floki.HTMLParser.FastHtml ) Or: use Mix.Config config :floki , :html_parser , Floki.HTMLParser.Mochiweb The default parser is Mochiweb, which comes with Floki. You can also choose between Html5ever or FastHtml. This module is also a behaviour that those parsers must implement.","ref":"Floki.HTMLParser.html","title":"Floki.HTMLParser","type":"behaviour"},{"doc":"","ref":"Floki.HTMLParser.html#parse_document/2","title":"Floki.HTMLParser.parse_document/2","type":"function"},{"doc":"","ref":"Floki.HTMLParser.html#c:parse_document/2","title":"Floki.HTMLParser.parse_document/2","type":"callback"},{"doc":"","ref":"Floki.HTMLParser.html#parse_fragment/2","title":"Floki.HTMLParser.parse_fragment/2","type":"function"},{"doc":"","ref":"Floki.HTMLParser.html#c:parse_fragment/2","title":"Floki.HTMLParser.parse_fragment/2","type":"callback"},{"doc":"","ref":"Mix.Tasks.GenerateEntities.html","title":"Mix.Tasks.GenerateEntities","type":"task"},{"doc":"It generates tests based on test files from WHATWG. This task will take a look at tokenizer test files that are located in &quot;./test/html5lib-tests/tokenizer&quot; and generate modules to run those tests. This is necessary every time the specs of HTML change, so we can keep up to date and also we can keep track of what changed.","ref":"Mix.Tasks.GenerateTokenizerTests.html","title":"Mix.Tasks.GenerateTokenizerTests","type":"task"},{"doc":"","ref":"Floki.ParseError.html","title":"Floki.ParseError","type":"exception"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added Add option to pass down arguments to the parser in Floki.parse_document/2 and Floki.parse_fragment/2 . Thanks @Kuret . Add support for returning more elements from the Floki.traverse_and_update/2 function callback. This enables the creation of more elements in the tree, but should be used with care, since the tree can grow a lot if the change is not controlled. Thanks @martosaur .","ref":"changelog.html#0-34-2-2023-02-24","title":"Changelog - 0.34.2 - 2023-02-24","type":"extras"},{"doc":"Fixed Fix pseudo-class &quot;:not&quot; selector parsing halting point. This is a fix for when a &quot;pseudo-class&quot; &quot;:not&quot; that contains an attribute selector is followed by another selector. This is an example: &quot;a:not([class]), div&quot;. Ignore decimal numeric char ref when number is negative.","ref":"changelog.html#0-34-1-2023-02-11","title":"Changelog - 0.34.1 - 2023-02-11","type":"extras"},{"doc":"Added User configurable &quot;self-closing&quot; tags. Now it's possible to define which tags are considered &quot;self-closing&quot;. Thanks @inoas . Fixed Allow attribute values to not be escaped. This fixes Floki.raw_html/2 when used with the option encode: false . Thanks @juanazam . Fix traverse_and_update/3 spec. Thanks @WLSF . Changed Drop support for Elixir 1.9 and 1.10. Remove html_entities dependency. We now use an internal encoder/decoder for entities. Change the main branch name to main .","ref":"changelog.html#0-34-0-2022-11-03","title":"Changelog - 0.34.0 - 2022-11-03","type":"extras"},{"doc":"Fixed Remove some warnings for unused code.","ref":"changelog.html#0-33-1-2022-06-28","title":"Changelog - 0.33.1 - 2022-06-28","type":"extras"},{"doc":"Added Add support for searching elements that contains text in a case-insensitive manner with fl-icontains - thanks @nuno84 Changed Drop support for Elixir 1.8 and 1.9. Fix and improve internal things - thanks @derek-zhou and @hissssst","ref":"changelog.html#0-33-0-2022-06-28","title":"Changelog - 0.33.0 - 2022-06-28","type":"extras"},{"doc":"Fixed Allow root nodes to be selected using pseudo-classes - thanks @rzane","ref":"changelog.html#0-32-1-2022-03-24","title":"Changelog - 0.32.1 - 2022-03-24","type":"extras"},{"doc":"Added Add an HTML tokenizer written in Elixir - this still experimental and it's not stable API yet. Add support for HTML IDs containing periods in the selectors - thanks @Hugo-Hache Add support for case-insensitive CSS attribute selectors - thanks @fcapovilla Add the :root pseudo-class selector - thanks @fcapovilla","ref":"changelog.html#0-32-0-2021-10-18","title":"Changelog - 0.32.0 - 2021-10-18","type":"extras"},{"doc":"Changed Treat style and title tags as plaintext in Mochiweb - thanks @SweetMNM","ref":"changelog.html#0-31-0-2021-06-11","title":"Changelog - 0.31.0 - 2021-06-11","type":"extras"},{"doc":"Fixed Fix typespecs of Floki.traverse_and_update/2 to make clear that it does not accept text nodes directly.","ref":"changelog.html#0-30-1-2021-03-29","title":"Changelog - 0.30.1 - 2021-03-29","type":"extras"},{"doc":"Added Add &quot;:disabled&quot; pseudo selector - thanks @vnegrisolo Add Gleam adapter - thanks @CrowdHailer Add pretty option to Floki.raw_html/2 - thanks @evaldobratti Add html_parser option to parse_ functions. This enables a more dynamic and functional configuration of the HTML parser in use. Changed Remove support for Elixir 1.7 - thanks @carlosfrodrigues Replace IO.warn by Logger.info for deprecation warnings - thanks @juulSme Fixed Fix typespecs for find , attr and attribute functions - thanks @mtarnovan Documentation Improvements - thanks @kianmeng","ref":"changelog.html#0-30-0-2021-02-06","title":"Changelog - 0.30.0 - 2021-02-06","type":"extras"},{"doc":"Added Add Floki.find_and_update/3 that updates nodes inside a tree, like traverse and update but without allowing changes in the children nodes. There for the tree cannot grow in size, but can have nodes removed. Changed Deprecate Floki.map/2 because we have now Floki.find_and_update/3 and Floki.traverse_and_update/2 that are powerful APIs. Floki.map/2 can be replaced by Enum.map/2 as well - thanks @josevalim for the idea! Update optional dependency fast_html to v2.0.4 Fixed Fix a bug when parsing a HTML with a XML inside using Mochiweb's parser Improvements Add more typespecs","ref":"changelog.html#0-29-0-2020-10-02","title":"Changelog - 0.29.0 - 2020-10-02","type":"extras"},{"doc":"Added Add support for :checked pseudo-class selector - thanks @wojtekmach Changed Drop support for Elixir 1.6 Update version of fast_html to 2.0 in docs and CI - thanks @rinpatch Fixed Fix docs by mentioning HTML nodes supported for traverse_and_update - thanks @hubertlepicki","ref":"changelog.html#0-28-0-2020-08-26","title":"Changelog - 0.28.0 - 2020-08-26","type":"extras"},{"doc":"Added Floki.filter_out/2 now can filter text nodes - thanks @ckruse Support more encoding entities in Floki.raw_html/1 - thanks @ntenczar Fixed Fix Floki.attribute/2 when there is only text nodes in the document - thanks @ckruse Improvements Performance improvements of Floki.raw_html/1 function - thanks @josevalim Improvements in the docs and specs of Floki.traverse_and_update/2 and Floki.children/1 - thanks @josevalim Improvements in the spec of Floki.traverse_and_update/2 - thanks @Dalgona Improve the CI setup to run the formatter correctly - thanks @Cleidiano","ref":"changelog.html#0-27-0-2020-07-07","title":"Changelog - 0.27.0 - 2020-07-07","type":"extras"},{"doc":"Added Add support for the pseudo-class selectors :nth-last-child and :nth-last-of-type Fixed Fix the typespecs of Floki.traverse_and_update/3 - thanks @RichMorin Changed Update optional dependency fast_html to v1.0.3","ref":"changelog.html#0-26-0-2020-02-17","title":"Changelog - 0.26.0 - 2020-02-17","type":"extras"},{"doc":"Added Add Floki.parse_fragment!/1 and Floki.parse_document!/1 that has the same functionality of the functions without the bang, but they return the document or fragment without the either tuple and will raise exception in case of errors - thanks @schneiderderek Add Floki.traverse_and_update/3 which accepts an accumulator which is useful to keep the state while traversing the HTML tree - thanks @Dalgona Changed Update the html_entities dependency from v0.5.0 to v0.5.1","ref":"changelog.html#0-25-0-2020-01-26","title":"Changelog - 0.25.0 - 2020-01-26","type":"extras"},{"doc":"Added Add support for fast_html , which is a &quot;C Node&quot; wrapping Lexborisov's myhtml - thanks @rinpatch Add setup to run our test suite against all parsers on CI - thanks @rinpatch Add Floki.parse_document/1 and Floki.parse_fragment/1 in order to correct parse documents and fragments of documents - it also prevents the confusion and inconsistency of parse/1 . Configure dialyxir in order to run Dialyzer easily. Changed Deprecate Floki.parse/1 and all the functions that uses it underneath. This means that all the functions that accepted HTML as binary are deprecated as well. This includes find/2 , attr/4 , filter_out/2 , text/2 and attribute/2 . The recommendation is to use those functions with an already parsed document or fragment. Remove support for Elixir 1.5 .","ref":"changelog.html#0-24-0-2020-01-01","title":"Changelog - 0.24.0 - 2020-01-01","type":"extras"},{"doc":"Fixed It fixes the Mochiweb parser when there is an invalid charref.","ref":"changelog.html#0-23-1-2019-12-01","title":"Changelog - 0.23.1 - 2019-12-01","type":"extras"},{"doc":"Changed Remove Mochiweb as a hex dependency. It brings the code from the original project to Floki's codebase - thanks @josevalim","ref":"changelog.html#0-23-0-2019-09-11","title":"Changelog - 0.23.0 - 2019-09-11","type":"extras"},{"doc":"Added Add Floki.traverse_and_update/2 that works in similar way to Floki.map/2 but traverse the tree and update the children elements. The difference from &quot;map&quot; is that this function can create a tree with more or less nodes. - thanks @ericlathrop Changed Remove support for Elixir 1.4.","ref":"changelog.html#0-22-0-2019-08-21","title":"Changelog - 0.22.0 - 2019-08-21","type":"extras"},{"doc":"Added Add a possibility to filter style tags on Floki.text/2 - thanks @Vict0rynox Fixed Fix Floki.text/2 to consider the previous filter of js when filtering style - thanks @Vict0rynox Fix typespecs for Floki.filter_out/2 - thanks @myfreeweb Changed Drop support for Elixir 1.3 and below - thanks @herbstrith","ref":"changelog.html#0-21-0-2019-04-17","title":"Changelog - 0.21.0 - 2019-04-17","type":"extras"},{"doc":"Fixed Fix Floki.raw_html to accept lists as attribute values - thanks @katehedgpeth","ref":"changelog.html#0-20-4-2018-09-24","title":"Changelog - 0.20.4 - 2018-09-24","type":"extras"},{"doc":"Fixed Fix style and script tags with comments - thanks @francois2metz","ref":"changelog.html#0-20-3-2018-06-22","title":"Changelog - 0.20.3 - 2018-06-22","type":"extras"},{"doc":"Fixed Fix Floki.raw_html/1 to correct handle quotes and double quotes on attributes - thanks @grych","ref":"changelog.html#0-20-2-2018-05-09","title":"Changelog - 0.20.2 - 2018-05-09","type":"extras"},{"doc":"Fixed Remove Enumerable.slice/1 compile warning for Floki.HTMLTree - thanks @thecodeboss Fix Floki.find/2 that was failing on HTML that consists entirely of a comment - thanks @ShaneWilton","ref":"changelog.html#0-20-1-2018-04-05","title":"Changelog - 0.20.1 - 2018-04-05","type":"extras"},{"doc":"Added Configurable raw_html/2 to allow optional encode of HTML entities - thanks @davydog187 Fixed Fix serialization of the tree after updating attribute - thanks @francois2metz","ref":"changelog.html#0-20-0-2018-02-06","title":"Changelog - 0.20.0 - 2018-02-06","type":"extras"},{"doc":"Fixed Skip HTML entities encode for Floki.raw_html/1 for script or style tags Add :html_entities app to the list of OTP applications. It fixes production releases.","ref":"changelog.html#0-19-3-2018-01-25","title":"Changelog - 0.19.3 - 2018-01-25","type":"extras"},{"doc":"Fixed (BREAKING CHANGE) Re-encode HTML entities on Floki.raw_html/1 .","ref":"changelog.html#0-19-2-2017-12-22","title":"Changelog - 0.19.2 - 2017-12-22","type":"extras"},{"doc":"Fixed Fixed doctype serialization for Floki.raw_html/1 - thanks [@jhchen][ https://github.com/jhchen]","ref":"changelog.html#0-19-1-2017-12-04","title":"Changelog - 0.19.1 - 2017-12-04","type":"extras"},{"doc":"Added Added support for nth-of-type , first-of-type , last-of-type and last-child pseudo-classes - thanks @saleem1337 . Added support for nth-child pseudo-class functional notation - thanks @nirev . Added functional notation support for nth-of-type pseudo-class. Added a Contributing guide . Fixed Format all files according to the Elixir 1.6 formatter - thanks @fcevado . Fix Floki.raw_html to support raw text - thanks @craig-day .","ref":"changelog.html#0-19-0-2017-11-11","title":"Changelog - 0.19.0 - 2017-11-11","type":"extras"},{"doc":"Added Added a Code of Conduct . Fixed Fix XML tag when building HTML tree. Return empty list when Floki.filter_out/2 result is empty.","ref":"changelog.html#0-18-1-2017-10-13","title":"Changelog - 0.18.1 - 2017-10-13","type":"extras"},{"doc":"Added Added Floki.attr/4 that receives a function enabling manipulation of attribute values - thanks @erikdsi . Implement the String.Chars protocol for Floki.Selector. Implement the Enumerable protocol for Floki.HTMLTree. Changed Changed Floki.transform/2 to Floki.map/2 and Floki.Finder.apply_transform/2 to Floki.Finder.map/2 - thanks @aphillipo . Fixed Fix Floki.raw_html/1 to consider XML prefixes - thanks @sergey-kintsel . Fix raw_html for self closing tags with content - thanks @navinpeiris . Removed Removed support for Elixir 1.2.","ref":"changelog.html#0-18-0-2017-08-05","title":"Changelog - 0.18.0 - 2017-08-05","type":"extras"},{"doc":"Fixed Fix attribute selectors in :not() - thanks @jjcarstens and @Eiji7 Fix selector parser to consider combinators across selectors separated by commas. For further details, please check the pull request - thanks @jjcarstens and @mischov","ref":"changelog.html#0-17-2-2017-05-25","title":"Changelog - 0.17.2 - 2017-05-25","type":"extras"},{"doc":"Fixed Fix search when body has unencoded angles ( &lt; and &gt; ) - thanks @sergey-kintsel Fix crash caused by XML declaration inside body - thanks @erikdsi Fix issue when finding fails if HTML begins with XML tag - thanks @sergey-kintsel","ref":"changelog.html#0-17-1-2017-05-22","title":"Changelog - 0.17.1 - 2017-05-22","type":"extras"},{"doc":"Added Add support for multiple pseudo-selectors, line :not() and :nth-child() - thanks @jjcarstens Add support for multiple selectors inside the :not() pseudo-class selector - thanks @jjcarstens","ref":"changelog.html#0-17-0-2017-04-12","title":"Changelog - 0.17.0 - 2017-04-12","type":"extras"},{"doc":"Added Add support for selectors that only include a pseudo-class selector - thanks @buhman Add support for a new selector: fl-contains , which returns elements that contains a given text - thanks @buhman Fixed Fix :not() pseudo-class selector to accept simple pseudo-class selectors as well - thanks @mischov","ref":"changelog.html#0-16-0-2017-04-05","title":"Changelog - 0.16.0 - 2017-04-05","type":"extras"},{"doc":"Added Added support for the :not() pseudo-class selector. Fixed Fixed pseudo-class selectors that are used in conjunction with combinators - thanks @Eiji7 Fixed order of elements after search using descendant combinator - thanks @Eiji7","ref":"changelog.html#0-15-0-2017-03-14","title":"Changelog - 0.15.0 - 2017-03-14","type":"extras"},{"doc":"Added Added support for configuring html5ever as the HTML parser. Issue #83 - thanks @hansihe and @aphillipo !","ref":"changelog.html#0-14-0-2017-02-07","title":"Changelog - 0.14.0 - 2017-02-07","type":"extras"},{"doc":"Fixed Fixed bug that was causing Floki.text/1 and Floki.filter_out/2 to ignore &quot;trees&quot; with only text nodes. Issue #91 - thanks @boydm .","ref":"changelog.html#0-13-2-2017-02-07","title":"Changelog - 0.13.2 - 2017-02-07","type":"extras"},{"doc":"Fixed Fix ordering of duplicated descendant matches - thanks @mmmries Fix ordering of Floki.text/1 when there are only root nodes - thanks @mmmries","ref":"changelog.html#0-13-1-2017-01-22","title":"Changelog - 0.13.1 - 2017-01-22","type":"extras"},{"doc":"Added Floki.filter_out/2 is now able to understand complex selectors to filter out from the tree.","ref":"changelog.html#0-13-0-2017-01-22","title":"Changelog - 0.13.0 - 2017-01-22","type":"extras"},{"doc":"Fixed Fix search for elements using descendant combinator - issue #84 - thanks @mmmries","ref":"changelog.html#0-12-1-2017-01-20","title":"Changelog - 0.12.1 - 2017-01-20","type":"extras"},{"doc":"Added Add basic support for nth-child pseudo-class selector. Closes issue #64 . Changed Remove support for Elixir 1.1 and below. Remove public documentation for internal code.","ref":"changelog.html#0-12-0-2016-12-28","title":"Changelog - 0.12.0 - 2016-12-28","type":"extras"},{"doc":"Added First attempt to transform nodes with Floki.transform/2 . It is not able to update the tree yet, but works good with results from Floki.find/2 - thanks @bobjflong Changed Using Logger to notify unknown tokens in selector parser - thanks @teamon and @geonnave Replace mochiweb_html with mochiweb package. This is needed to fix conflict with other packages that are using mochiweb . - thanks @aphillipo","ref":"changelog.html#0-11-0-2016-10-12","title":"Changelog - 0.11.0 - 2016-10-12","type":"extras"},{"doc":"Fixed Fix sibling search after immediate children - thanks @gmile .","ref":"changelog.html#0-10-1-2016-08-28","title":"Changelog - 0.10.1 - 2016-08-28","type":"extras"},{"doc":"Changed Change the search for namespaced elements using the correct CSS3 syntax. Fixed Fix the search for child elements when is more than two elements deep - thanks @gmile","ref":"changelog.html#0-10-0-2016-08-05","title":"Changelog - 0.10.0 - 2016-08-05","type":"extras"},{"doc":"Added A separator between text when getting text from nodes - thanks @rochdi .","ref":"changelog.html#0-9-0-2016-06-16","title":"Changelog - 0.9.0 - 2016-06-16","type":"extras"},{"doc":"Added Support rendering boolean attributes on Floki.raw_html/1 - thanks @iamvery . Changed Update Mochiweb HTML parser dependency to version 2.15.0.","ref":"changelog.html#0-8-1-2016-05-20","title":"Changelog - 0.8.1 - 2016-05-20","type":"extras"},{"doc":"Added Add possibility to search tags with namespaces. Accept Floki.Selector as parameter of Floki.find/2 instead of only strings - thanks @hansihe . Changed Using a smaller package with only the Mochiweb HTML parser.","ref":"changelog.html#0-8-0-2016-03-06","title":"Changelog - 0.8.0 - 2016-03-06","type":"extras"},{"doc":"Fixed Replace &lt;br&gt; nodes by newline ( \\n ) in DeepText - thanks @maxneuvians . Allow FilterOut to filter special nodes, like comment .","ref":"changelog.html#0-7-2-2016-02-23","title":"Changelog - 0.7.2 - 2016-02-23","type":"extras"},{"doc":"Fixed Ignore PHP scripts when finding nodes.","ref":"changelog.html#0-7-1-2015-11-14","title":"Changelog - 0.7.1 - 2015-11-14","type":"extras"},{"doc":"Added Add support for excluding script notes in Floki.text . By default, it will exclude those nodes, but it can be enabled with the flag js: true - thanks @vikeri ! Fixed Fix find for sibling nodes when the precedent selector match an element at the end of sibling list - fix issue #39","ref":"changelog.html#0-7-0-2015-11-03","title":"Changelog - 0.7.0 - 2015-11-03","type":"extras"},{"doc":"Fixed Fix the Floki.raw_html/1 to build HTML comments properly.","ref":"changelog.html#0-6-1-2015-10-11","title":"Changelog - 0.6.1 - 2015-10-11","type":"extras"},{"doc":"Added Add Floki.raw_html/2 .","ref":"changelog.html#0-6-0-2015-10-07","title":"Changelog - 0.6.0 - 2015-10-07","type":"extras"},{"doc":"Added Add the child combinator to Floki.find/2 . Add the adjacent sibling combinator to Floki.find/2 . Add the general adjacent sibling combinator to Floki.find/2 .","ref":"changelog.html#0-5-0-2015-09-27","title":"Changelog - 0.5.0 - 2015-09-27","type":"extras"},{"doc":"Fixed Ignoring other files that are not lexer files (&quot;.xrl&quot;) under src/ directory in Hex package. This fixes a crash when compiling using OTP 17.5 on Mac OS X. Huge thanks to @henrik and @licyeus that pointed the issue !","ref":"changelog.html#0-4-1-2015-09-18","title":"Changelog - 0.4.1 - 2015-09-18","type":"extras"},{"doc":"Added A robust representation of selectors in order to enable queries using a mix of selector types, such as classes with attributes, attributes with types, classes with classes and so on. Here is a list with examples of what is possible now: Floki.find(html, &quot;a.foo&quot;) Floki.find(html, &quot;a.foo[data-action=post]&quot;) Floki.find(html, &quot;.foo.bar&quot;) Floki.find(html, &quot;a.foo[href$='.org']&quot;) Thanks to @licyeus to point out the issue ! Include mochiweb in the applications list at mix.exs - thanks @EricDykstra Changed Floki.find/2 will now return a list instead of tuple when searching only by IDs. For now on, Floki should always return the results inside a list, even if it's an ID match. Removed Floki.find/2 does not accept tuples as selectors anymore. This is because with the robust selectors representation, it won't be necessary to query directly using tuples or another data structures rather than string.","ref":"changelog.html#0-4-0-2015-09-17","title":"Changelog - 0.4.0 - 2015-09-17","type":"extras"},{"doc":"Fixed Fix Floki.find/2 when there is a non-HTML input. It closes the issue #17","ref":"changelog.html#0-3-3-2015-08-23","title":"Changelog - 0.3.3 - 2015-08-23","type":"extras"},{"doc":"Fixed Fix Floki.DeepText when there is a comment inside nodes.","ref":"changelog.html#0-3-2-2015-06-27","title":"Changelog - 0.3.2 - 2015-06-27","type":"extras"},{"doc":"Fixed Fix Floki.find/2 to consider XML trees.","ref":"changelog.html#0-3-1-2015-06-21","title":"Changelog - 0.3.1 - 2015-06-21","type":"extras"},{"doc":"Added Add attribute equals selector. This feature enables the user to search using HTML attributes other than &quot;class&quot; or &quot;id&quot;. E.g: Floki.find(html, &quot;[data-model=user]&quot;) - @nelsonr","ref":"changelog.html#0-3-0-2015-06-07","title":"Changelog - 0.3.0 - 2015-06-07","type":"extras"},{"doc":"Fixed Fix parse/1 when parsing a part of HTML without a root node - @antonmi","ref":"changelog.html#0-2-1-2015-06-04","title":"Changelog - 0.2.1 - 2015-06-04","type":"extras"},{"doc":"Added Support HTML string when searching for attributes with Floki.attribute/2 . Option for Floki.text/2 to disable deep search and use flat search instead. Changed Change Floki.text/1 to perform a deep search of text nodes. Consider doctests in the test suite.","ref":"changelog.html#0-2-0-2015-05-03","title":"Changelog - 0.2.0 - 2015-05-03","type":"extras"},{"doc":"Added Add CHANGELOG.md following the Keep a changelog . Changed Using MochiWeb as a hex dependency instead of embedded code. It closes the issue #5","ref":"changelog.html#0-1-1-2015-03-25","title":"Changelog - 0.1.1 - 2015-03-25","type":"extras"},{"doc":"Added Descendant selectors, like &quot;.class tag&quot; to Floki.find/2. Multiple selection, like &quot;.class1, .class2&quot; to Floki.find/2.","ref":"changelog.html#0-1-0-2015-02-15","title":"Changelog - 0.1.0 - 2015-02-15","type":"extras"},{"doc":"Added Floki.text/1 , which returns all text in the same level of the parent element inside HTML. Changed Elixir version requirement from &quot;~&gt; 1.0.0&quot; to &quot;&gt;= 1.0.0&quot;.","ref":"changelog.html#0-0-5-2014-12-21","title":"Changelog - 0.0.5 - 2014-12-21","type":"extras"},{"doc":"Floki is a simple HTML parser that enables search for nodes using CSS selectors . Check the documentation 📙 .","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Take this HTML as an example: &lt;!doctype html&gt; &lt;html&gt; &lt;body&gt; &lt;section id=&quot;content&quot;&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; &lt;span class=&quot;headline&quot;&gt;Enables search using CSS selectors&lt;/span&gt; &lt;a href=&quot;https://github.com/philss/floki&quot;&gt;Github page&lt;/a&gt; &lt;span data-model=&quot;user&quot;&gt;philss&lt;/span&gt; &lt;/section&gt; &lt;a href=&quot;https://hex.pm/packages/floki&quot;&gt;Hex package&lt;/a&gt; &lt;/body&gt; &lt;/html&gt; Here are some queries that you can perform (with return examples): { :ok , document } = Floki . parse_document ( html ) Floki . find ( document , &quot;p.headline&quot; ) # =&gt; [{&quot;p&quot;, [{&quot;class&quot;, &quot;headline&quot;}], [&quot;Floki&quot;]}] document |&gt; Floki . find ( &quot;p.headline&quot; ) |&gt; Floki . raw_html # =&gt; &lt;p class=&quot;headline&quot;&gt;Floki&lt;/p&gt; Each HTML node is represented by a tuple like: { tag_name , attributes , children_nodes } Example of node: { &quot;p&quot; , [ { &quot;class&quot; , &quot;headline&quot; } ] , [ &quot;Floki&quot; ] } So even if the only child node is the element text, it is represented inside a list.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Add Floki to your mix.exs : defp deps do [ { :floki , &quot;~&gt; 0.34.0&quot; } ] end After that, run mix deps.get . You can check the changelog for changes.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Floki needs the :leex module in order to compile. Normally this module is installed with Erlang in a complete installation. If you get this &quot;module :leex is not available&quot; error message, you need to install the erlang-dev and erlang-parsetools packages in order get the :leex module. The packages names may be different depending on your OS. Alternative HTML parsers By default Floki uses a patched version of mochiweb_html for parsing fragments due to its ease of installation (it's written in Erlang and has no outside dependencies). However one might want to use an alternative parser due to the following concerns: Performance - It can be up to 20 times slower than the alternatives on big HTML documents. Correctness - in some cases mochiweb_html will produce different results from what is specified in HTML5 specification . For example, a correct parser would parse &lt;title&gt; &lt;b&gt; bold &lt;/b&gt; text &lt;/title&gt; as {&quot;title&quot;, [], [&quot; &lt;b&gt; bold &lt;/b&gt; text &quot;]} since content inside &lt;title&gt; is to be treated as plaintext . Albeit mochiweb_html would parse it as {&quot;title&quot;, [], [{&quot;b&quot;, [], [&quot; bold &quot;]}, &quot; text &quot;]} . Floki supports the following alternative parsers: fast_html - A wrapper for lexbor . A pure C HTML parser. html5ever - A wrapper for html5ever written in Rust, developed as a part of the Servo project. fast_html is generally faster, according to the benchmarks conducted by its developers. You can perform a benchmark by running the following: $ sh benchs/extract.sh $ mix run benchs/parse_document.exs Extracting the files is needed only once. Using html5ever as the HTML parser This dependency is written with a NIF using Rustler , but you don't need to install anything to compile it thanks to RustlerPrecompiled . defp deps do [ { :floki , &quot;~&gt; 0.34.0&quot; } , { :html5ever , &quot;~&gt; 0.14.0&quot; } ] end Run mix deps.get and compiles the project with mix compile to make sure it works. Then you need to configure your app to use html5ever : # in config/config.exs config :floki , :html_parser , Floki.HTMLParser.Html5ever Notice that you can pass the HTML parser as an option in parse_document/2 and parse_fragment/2 . Using fast_html as the HTML parser A C compiler, GNU\\Make and CMake need to be installed on the system in order to compile lexbor. First, add fast_html to your dependencies: defp deps do [ { :floki , &quot;~&gt; 0.34.0&quot; } , { :fast_html , &quot;~&gt; 2.0&quot; } ] end Run mix deps.get and compiles the project with mix compile to make sure it works. Then you need to configure your app to use fast_html : # in config/config.exs config :floki , :html_parser , Floki.HTMLParser.FastHtml","ref":"readme.html#dependencies","title":"Overview - Dependencies","type":"extras"},{"doc":"To parse a HTML document, try: html = &quot;&quot;&quot; &lt;html&gt; &lt;body&gt; &lt;div class=&quot;example&quot;&gt;&lt;/div&gt; &lt;/body&gt; &lt;/html&gt; &quot;&quot;&quot; { :ok , document } = Floki . parse_document ( html ) # =&gt; {:ok, [{&quot;html&quot;, [], [{&quot;body&quot;, [], [{&quot;div&quot;, [{&quot;class&quot;, &quot;example&quot;}], []}]}]}]} To find elements with the class example , try: Floki . find ( document , &quot;.example&quot; ) # =&gt; [{&quot;div&quot;, [{&quot;class&quot;, &quot;example&quot;}], []}] To convert your node tree back to raw HTML (spaces are ignored): document |&gt; Floki . find ( &quot;.example&quot; ) |&gt; Floki . raw_html # =&gt; &lt;div class=&quot;example&quot;&gt;&lt;/div&gt; To fetch some attribute from elements, try: Floki . attribute ( document , &quot;.example&quot; , &quot;class&quot; ) # =&gt; [&quot;example&quot;] You can get attributes from elements that you already have: document |&gt; Floki . find ( &quot;.example&quot; ) |&gt; Floki . attribute ( &quot;class&quot; ) # =&gt; [&quot;example&quot;] If you want to get the text from an element, try: document |&gt; Floki . find ( &quot;.headline&quot; ) |&gt; Floki . text # =&gt; &quot;Floki&quot;","ref":"readme.html#more-about-floki-api","title":"Overview - More about Floki API","type":"extras"},{"doc":"Here you find all the CSS selectors supported in the current version: Pattern Description * any element E an element of type E E[foo] an E element with a &quot;foo&quot; attribute E[foo=&quot;bar&quot;] an E element whose &quot;foo&quot; attribute value is exactly equal to &quot;bar&quot; E[foo~=&quot;bar&quot;] an E element whose &quot;foo&quot; attribute value is a list of whitespace-separated values, one of which is exactly equal to &quot;bar&quot; E[foo^=&quot;bar&quot;] an E element whose &quot;foo&quot; attribute value begins exactly with the string &quot;bar&quot; E[foo$=&quot;bar&quot;] an E element whose &quot;foo&quot; attribute value ends exactly with the string &quot;bar&quot; E[foo*=&quot;bar&quot;] an E element whose &quot;foo&quot; attribute value contains the substring &quot;bar&quot; E[foo|=&quot;en&quot;] an E element whose &quot;foo&quot; attribute has a hyphen-separated list of values beginning (from the left) with &quot;en&quot; E:nth-child(n) an E element, the n-th child of its parent E:nth-last-child(n) an E element, the n-th child of its parent, counting from bottom to up E:first-child an E element, first child of its parent E:last-child an E element, last child of its parent E:nth-of-type(n) an E element, the n-th child of its type among its siblings E:nth-last-of-type(n) an E element, the n-th child of its type among its siblings, counting from bottom to up E:first-of-type an E element, first child of its type among its siblings E:last-of-type an E element, last child of its type among its siblings E:checked An E element (checkbox, radio, or option) that is checked E:disabled An E element (button, input, select, textarea, or option) that is disabled E.warning an E element whose class is &quot;warning&quot; E#myid an E element with ID equal to &quot;myid&quot; (for ids containing periods, use #my\\\\.id or [id=&quot;my.id&quot;] ) E:not(s) an E element that does not match simple selector s :root the root node or nodes (in case of fragments) of the document. Most of the times this is the html tag E F an F element descendant of an E element E &gt; F an F element child of an E element E + F an F element immediately preceded by an E element E ~ F an F element preceded by an E element There are also some selectors based on non-standard specifications. They are: Pattern Description E:fl-contains('foo') an E element that contains &quot;foo&quot; inside a text node E:fl-icontains('foo') an E element that contains &quot;foo&quot; inside a text node (case insensitive)","ref":"readme.html#supported-selectors","title":"Overview - Supported selectors","type":"extras"},{"doc":"@arasatasaygin for Floki's logo from the Open Logos project .","ref":"readme.html#special-thanks","title":"Overview - Special thanks","type":"extras"},{"doc":"Copyright (c) 2014 Philip Sampaio Silva Floki is under MIT license. Check the LICENSE file for more details.","ref":"readme.html#license","title":"Overview - License","type":"extras"}]